package ModuleMapSolutionEval;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Random;


import main_scripts.AlgorithmComparison_main_for_binary_graphs;
import main_scripts.DICER_main;
import math_utils.ClassesFileObject;
import math_utils.ExpressionMatrix;
import multithreaded_algo_runs.MultithreadedComparisonRunner;

public class AlgorithmComparison_DC_CV {

	public static void main(String[] args) {
		if (args.length < 4) {
			System.out
					.println("usage: <GE matrix> <classes file><classIndex><outPath><optional: use ppi as positive network>");
		}

		int classIndex = Integer.parseInt(args[2]);
		
		ExpressionMatrix all_data_mat = new ExpressionMatrix(args[0]);		
		HashSet<String> mat_genes = new HashSet<String>(all_data_mat.genesID);
		Hashtable<String, Integer> gene2index = new Hashtable<String, Integer>();
		for (int i = 0; i < all_data_mat.genesID.size(); i++) {
			gene2index.put(all_data_mat.genesID.get(i), i);
		}
		
		Hashtable<String, AlgorithmEvaluationResults> algo2testEval = new Hashtable<String, AlgorithmEvaluationResults>();
		Hashtable<String, AlgorithmEvaluationResults> algo2trainingEval = new Hashtable<String, AlgorithmEvaluationResults>();
		
		float[][] g1=null;
		
		if (args.length>4){
			g1 = AlgorithmComparison_main_for_binary_graphs.getGraphAsMatrix(args[4], mat_genes, gene2index);
			float numEdges = 0;
			LinkedList<Integer> toRemove = new LinkedList<Integer>();
			int[] degs = new int[g1.length];
			for (int i = 0; i < g1.length; i++) {
				float curr_deg = 0;
				for (int j = 0; j < degs.length; j++) {
					if (g1[i][j]<0){continue;}
					curr_deg+=g1[i][j];
				}
				if ((new Float(curr_deg)).intValue()<=5){
					toRemove.add(i);
				}
				numEdges+=curr_deg;
			}
			
			System.out.println(numEdges/2);
			all_data_mat = all_data_mat.removeGenes(toRemove);
			System.out.println("num remaining genes: " + all_data_mat.matrix.length);
			
			// update g1
			mat_genes = new HashSet<String>(all_data_mat.genesID);
			gene2index = new Hashtable<String, Integer>();
			for (int i = 0; i < all_data_mat.genesID.size(); i++) {
				gene2index.put(all_data_mat.genesID.get(i), i);
			}
			g1 = AlgorithmComparison_main_for_binary_graphs.getGraphAsMatrix(args[4], mat_genes, gene2index);
			Runtime.getRuntime().gc();
		}
		
		ClassesFileObject[][] foldsData = stratifiedCrossValidation(
				all_data_mat, args[1], new Random(), 2);

		for (int i = 0; i < foldsData[0].length; i++) {
					
			ExpressionMatrix mat = foldsData[0][i].getData();
			
			DICER_main trAnalyzer = new DICER_main(foldsData[0][i],
					Integer.parseInt(args[2]), args[3]);

			trAnalyzer.doStatisticalAnalysis(0.05f,true,false,0.3f);
			
			if (g1==null){
				g1 = trAnalyzer.getConsistentCorrelationsGraph();
			}
			float[][] g2_opt1 = trAnalyzer.uGGraph;

			float thr=0;
			System.out.println("### "+thr);

			MultithreadedComparisonRunner comp = new MultithreadedComparisonRunner(g1,
					g2_opt1, mat.genesID, thr,0.00001f);
			trAnalyzer = null;
//			diffCoExCalc = null;
			Runtime.getRuntime().gc();
			comp.doComparisons(true);
			Runtime.getRuntime().gc();
			
			
			LinkedList<String> algos = new LinkedList<String>(
					comp.algo2modulesAfterImprovement.keySet());
			for (Iterator<String> iterator = algos.iterator(); iterator.hasNext();) {
				String algo = (String) iterator.next();
				
				if(i==0){
					algo2testEval.put(algo, new AlgorithmEvaluationResults(algo, 2));
					algo2trainingEval.put(algo, new AlgorithmEvaluationResults(algo, 2));
				}
				if (comp.algo2CMPs.get(algo)!=null && comp.algo2modulesAfterImprovement.get(algo)!=null){
					algo2testEval.get(algo).addFoldResults(comp.algo2modulesAfterImprovement.get(algo), comp.algo2CMPs.get(algo)
							, foldsData[1][i], classIndex);
					algo2trainingEval.get(algo).addFoldResults(comp.algo2modulesAfterImprovement.get(algo), comp.algo2CMPs.get(algo)
							, foldsData[0][i], classIndex);
				}
			}
		}
		
		LinkedList<String> algos = new LinkedList<String>(algo2testEval.keySet());
		Collections.sort(algos);
		System.out.println("##### Average performance on training set ######");
		System.out.println(AlgorithmEvaluationResults.getToStringHeader());
		for (Iterator<String> iterator = algos.iterator(); iterator.hasNext();) {
			String a = (String) iterator.next();
			System.out.println(algo2trainingEval.get(a));
		}
		System.out.println("##### Average performance on test set ######");
		System.out.println(AlgorithmEvaluationResults.getToStringHeader());
		for (Iterator<String> iterator = algos.iterator(); iterator.hasNext();) {
			String a = (String) iterator.next();
			System.out.println(algo2testEval.get(a));
		}
	}

	public static float getThresholdForHGTest(float[][] g2_opt1, float q) {
		// get edge threshold for HG test.
		float meanPlus = 0;
		float c = 0;
		float[][] m = g2_opt1;
		for (int i = 0; i < m.length; i++) {
			for (int j = 0; j < i; j++) {
				if (m[i][j] > 0) {
					c++;
					meanPlus += m[i][j];
				}
			}
		}
		if (c>0){
			System.out.println("mean: " + meanPlus / c);
		}
		else{
			System.exit(1);
		}

//		int n = 100000;
//		float[] randArr = new float[n];
//		int pointer = 0;
//		Random r = new Random();
//		while (pointer < randArr.length) {
//			int n1 = r.nextInt(m.length);
//			int n2 = r.nextInt(m.length);
//			while (n1 == n2) {
//				n2 = r.nextInt(m.length);
//			}
//			if (m[n1][n2] > 0) {
//				randArr[pointer] = m[n1][n2];
//				pointer++;
//			}
//		}
//		Arrays.sort(randArr);
//		float thr = randArr[(new Float(n * (q))).intValue()];
//		System.out.println(q + " quantile: " + thr);
		return 0;
	}

	public static ClassesFileObject[][] stratifiedCrossValidation(
			ExpressionMatrix mat, String classesFilePath, Random rand, int folds) {
		
		Hashtable<String, ArrayList<Integer>> class2indices = new Hashtable<String, ArrayList<Integer>>();
		LinkedList<String> classes = new LinkedList<String>();
		ClassesFileObject[][] tr_te_folds = new ClassesFileObject[2][folds];
		try {
			BufferedReader reader = new BufferedReader(new FileReader(
					classesFilePath));
			String line = "";
			while ((line = reader.readLine()) != null) {
				String[] arr = line.split("\t");
				int from = Integer.parseInt(arr[0]);
				int to = Integer.parseInt(arr[1]);
				String clName = arr[2];
				classes.add(clName);
				ArrayList<Integer> indices = new ArrayList<Integer>(to - from
						+ 1);
				for (int i = from; i <= to; i++) {
					indices.add(i);
				}
				Collections.shuffle(indices, rand);
				class2indices.put(clName, indices);
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		ClassesFileObject[] trs = new ClassesFileObject[folds];
		ClassesFileObject[] tes = new ClassesFileObject[folds];
		int[] classPointers = new int[classes.size()];
		for (int i = 0; i < folds; i++) {
			System.out.println("fold: " +i);
			LinkedList<Integer> currTeIndices = new LinkedList<Integer>();
			int[] teBorders = new int[classes.size() * 2];
			int numTeSamples = 0;
			LinkedList<Integer> currTrIndices = new LinkedList<Integer>();
			int[] trBorders = new int[classes.size() * 2];
			int numTrSamples = 0;
			String[] names = new String[classes.size()];
			int bordersPointer = 0;

			for (int j = 0; j < classPointers.length; j++) {
				System.out.println("class: " + j);
				String currClass = classes.get(j);
				int foldSize = class2indices.get(currClass).size() / folds;
				int currStart = classPointers[j];
				int currEnd = currStart + foldSize;
				if (i == folds - 1) {
					currEnd = class2indices.get(currClass).size() - 1;
				}
				int currClassTeSize = currEnd - currStart + 1;
				System.out.println("te size: " + currClassTeSize);
				int currClassTrSize = class2indices.get(currClass).size()
						- currClassTeSize;
				System.out.println("tr size: " + currClassTrSize);
				for (int k = 0; k < class2indices.get(currClass).size(); k++) {
					if (k >= currStart && k <= currEnd) {
						currTeIndices.add(class2indices.get(currClass).get(k));
					} else {
						currTrIndices.add(class2indices.get(currClass).get(k));
					}

				}
				classPointers[j] = currEnd + 1;
				teBorders[bordersPointer] = numTeSamples;
				teBorders[bordersPointer + 1] = numTeSamples + currClassTeSize-1;
				System.out.println("curr te borders: " + teBorders[bordersPointer] + ", " + teBorders[bordersPointer+1]);
				numTeSamples += currClassTeSize;
				trBorders[bordersPointer] = numTrSamples;
				trBorders[bordersPointer + 1] = numTrSamples + currClassTrSize-1;
				System.out.println("curr tr borders: " + trBorders[bordersPointer] + ", " + trBorders[bordersPointer+1]);
				numTrSamples += currClassTrSize;
				names[j] = currClass;
				bordersPointer += 2;
			}

			trs[i] = new ClassesFileObject(classes.size(), trBorders, names,
					mat.getSubMatrixByColumnsIndices(new ArrayList<Integer>(
							currTrIndices)));

			tes[i] = new ClassesFileObject(classes.size(), teBorders, names,
					mat.getSubMatrixByColumnsIndices(new ArrayList<Integer>(
							currTeIndices)));
		}

		tr_te_folds[0] = trs;
		tr_te_folds[1] = tes;
		return tr_te_folds;
	}

}
