package ModuleMapSolutionEval;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import math_utils.staticMathHelperMethods;

public class SolutionSizeStatistics {
	List<HashSet<Integer>> solution;
	short[][] map;
	// module stats
	float[] sizes;
	double mean;
	double sd;
	double max;
	// network stats
	double numEdges;
	double meanDegree;
	double maxDegreee;
	
	public SolutionSizeStatistics(List<HashSet<Integer>> s, short[][] m) {
		solution=s;
		map=m;
		
		HashSet<Integer> coveredGenes  = new HashSet<Integer>();
		sizes = new float[solution.size()];
		int c=0;
		for (Iterator<HashSet<Integer>> iterator = solution.iterator(); iterator.hasNext();) {
			HashSet<Integer> module = (HashSet<Integer>) iterator.next();
			coveredGenes.addAll(module);
			sizes[c]=module.size();
			mean+=module.size();
			if (module.size()>max){
				max=module.size();
			}
			c++;
		}
		
		mean /= (double)solution.size();
		sd = staticMathHelperMethods.sStatistic(sizes, (new Double(mean)).floatValue());
		
		maxDegreee=0;
		for (int i = 0; i < map.length; i++) {
			float currDeg = 0;
			for (int j = 0; j < map.length; j++) {
				currDeg+=map[i][j];
			}
			numEdges+=currDeg;
			meanDegree+=currDeg;
			if (currDeg>maxDegreee){
				maxDegreee=currDeg;
			}
		}
		
		numEdges/=2;
		meanDegree /= (double)map.length;
		
	}
	
	
	public short[][] getMap() {
		return map;
	}
	public double getMax() {
		return max;
	}
	public double getMaxDegreee() {
		return maxDegreee;
	}
	public double getMean() {
		return mean;
	}
	public double getMeanDegree() {
		return meanDegree;
	}
	public double getNumEdges() {
		return numEdges;
	}
	public double getSd() {
		return sd;
	}
	public float[] getSizes() {
		return sizes;
	}
	public List<HashSet<Integer>> getSolution() {
		return solution;
	}
	
}
