package global_analysis;

import java.util.HashSet;

public class MergeOperationObject implements Comparable<MergeOperationObject> {
	float mergeGain;
	int i,j;
	HashSet<Integer> FriendsOfI,FriendsOfJ;
	HashSet<Integer> FriendsOfUnion;
	
	HashSet<Integer> NonSigFriendsOfI,NonSigFriendsOfJ;
	HashSet<Integer> NonSigFriendsOfUnion;
	
	float withinGain;
	float betweenLoss;
	
	HashSet<Integer> union;
	
	public MergeOperationObject(int a, int b,HashSet<Integer> fa, HashSet<Integer> fb,HashSet<Integer> nfa,HashSet<Integer> nfb) {
		// i to a
		if (a<b){
			i=a;
			j=b;
			setFi(fa);
			setFj(fb);
			setNonSigFriendsOfI(nfa);
			setNonSigFriendsOfJ(nfb);
		}
		// i to b
		else{
			j=a;
			i=b;
			setFi(fb);
			setFj(fa);
			setNonSigFriendsOfI(nfb);
			setNonSigFriendsOfJ(nfa);
		}
		
		FriendsOfUnion = new HashSet<Integer>();
		NonSigFriendsOfUnion = new HashSet<Integer>();
	}
	
	public void setFi(HashSet<Integer> fi) {
		FriendsOfI = new HashSet<Integer>(fi);
	}
	public void setFj(HashSet<Integer> fj) {
		FriendsOfJ = new HashSet<Integer>(fj);
	}
	public void setFij(HashSet<Integer> fij) {
		FriendsOfUnion = fij;
	}
	public void setMergeGain(float mergeGain) {
		this.mergeGain = mergeGain;
	}
	
	public void setUnion(HashSet<Integer> union) {
		this.union = union;
	}
	public void setBetweenLoss(float betweenLoss) {
		this.betweenLoss = betweenLoss;
	}
	
	public void setWithinGain(float withinGain) {
		this.withinGain = withinGain;
	}
	
	public HashSet<Integer> getFij() {
		return FriendsOfUnion;
	}
	
	
	public HashSet<Integer> getFiUnionFj() {
		HashSet<Integer> fi_fj = new HashSet<Integer>();
		fi_fj.addAll(FriendsOfI);
		fi_fj.addAll(FriendsOfJ);
		return fi_fj;
	}
	
//	public HashSet<Integer> getNonSigFiUnionNonSigFj() {
//		HashSet<Integer> fi_fj = new HashSet<Integer>();
//		fi_fj.addAll(NonSigFriendsOfI);
//		fi_fj.addAll(NonSigFriendsOfJ);
//		return fi_fj;
//	}
	
	public float getMergeGain() {
		return mergeGain;
	}
	
	public int getI() {
		return i;
	}
	
	public int getJ() {
		return j;
	}
	
	public HashSet<Integer> getUnion() {
		return union;
	}
	
//	public void setFriendsArr(short[] friendsArr) {
//		this.friendsArr = friendsArr;
//	}
//	public short[] getFriendsArr() {
//		return friendsArr;
//	}
	
	public HashSet<Integer> getNonSigFriendsOfI() {
		return NonSigFriendsOfI;
	}
	public HashSet<Integer> getNonSigFriendsOfJ() {
		return NonSigFriendsOfJ;
	}
	public HashSet<Integer> getNonSigFriendsOfUnion() {
		return NonSigFriendsOfUnion;
	}
	public void setNonSigFriendsOfI(HashSet<Integer> nonSigFriendsOfI) {
		NonSigFriendsOfI = new HashSet<Integer>(nonSigFriendsOfI);
	}
	public void setNonSigFriendsOfJ(HashSet<Integer> nonSigFriendsOfJ) {
		NonSigFriendsOfJ = new HashSet<Integer>(nonSigFriendsOfJ);;
	}
	
	public void setNonSigFriendsOfUnion(HashSet<Integer> nonSigFriendsOfUnion) {
		NonSigFriendsOfUnion = nonSigFriendsOfUnion;
	}

	@Override
	public int compareTo(MergeOperationObject arg0) {
		if (mergeGain>arg0.mergeGain){
			return 1;
		}
		return -1;
	}
	
	@Override
	public String toString() {
		return ""+mergeGain;
	}
	
	public String toFullString(){
		String out = "";
		out =i+","+j+"\n"
		+"G1 gain: " + withinGain+"\n"
		+"merge gain: " + mergeGain ;
		
		return out;
		
	}
	
}
