package global_analysis;

import java.util.Iterator;
import java.util.LinkedList;

public class TopKScoresContainer<T extends Comparable<T>> {

	/* Members */
	LinkedList<T> list;
	int k;
	T minObj;
	
	public TopKScoresContainer(int k) {
		list = new LinkedList<T>();
		this.k=k;
		minObj=null;
	}
	
	public void add(T t){
		
		if (minObj!=null && minObj.compareTo(t)>0){
			return;
		}
		
		int pointer = 0;
		for (Iterator<T> iterator = list.iterator(); iterator.hasNext();) {
			T listElem = (T) iterator.next();
			if (listElem.compareTo(t)>0){
				pointer++;
			}
			else{
				break;
			}
		}
		
		list.add(pointer, t);
		
		if (pointer==k-1){
			minObj=t;
		}
		
		if (list.size()>k){
			list.remove(k);
		}
		
	}
	
	public LinkedList<T> getList() {
		return list;
	}
	
	@Override
	public String toString() {
		String out = "";
		for (Iterator<T> iterator = list.iterator(); iterator.hasNext();) {
			T t = (T) iterator.next();
			out+=t.toString()+",";
		}
		return out;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TopKScoresContainer<Integer> c = new TopKScoresContainer<Integer>(2);
		System.out.println(c);
		c.add(1);
		System.out.println(c);
		c.add(2);
		System.out.println(c);
		c.add(1);
		System.out.println(c);
		c.add(10);
		System.out.println(c);
		c.add(100);
		System.out.println(c);
		c.add(-10);
		System.out.println(c);
		c.add(-100);
		System.out.println(c);
		c.add(1000);
		System.out.println(c);

	}

}
