package main_scripts;

import java.util.HashSet;
import java.util.Hashtable;
import java.util.LinkedList;

import math_utils.ExpressionMatrix;
import multithreaded_algo_runs.MultithreadedComparisonRunner;

public class AlgorithmComparisonMain_for_DC {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length < 4) {
			System.out
					.println("usage: <GE matrix> <classes file><classIndex><outPath><optional: ppi>");
		}
		
		ExpressionMatrix all_data_mat = new ExpressionMatrix(args[0]);		
		HashSet<String> mat_genes = new HashSet<String>(all_data_mat.genesID);
		Hashtable<String, Integer> gene2index = new Hashtable<String, Integer>();
		for (int i = 0; i < all_data_mat.genesID.size(); i++) {
			gene2index.put(all_data_mat.genesID.get(i), i);
		}
		float[][] g1=null;
		if (args.length>4){
			g1 = AlgorithmComparison_main_for_binary_graphs.getGraphAsMatrix(args[4], mat_genes, gene2index);
			float numEdges = 0;
			LinkedList<Integer> toRemove = new LinkedList<Integer>();
			int[] degs = new int[g1.length];
			for (int i = 0; i < g1.length; i++) {
				float curr_deg = 0;
				for (int j = 0; j < degs.length; j++) {
					if (g1[i][j]<0){continue;}
					curr_deg+=g1[i][j];
				}
				if ((new Float(curr_deg)).intValue()<=5){
					toRemove.add(i);
				}
				numEdges+=curr_deg;
			}
			
			System.out.println(numEdges/2);
			all_data_mat = all_data_mat.removeGenes(toRemove);
			System.out.println("num remaining genes: " + all_data_mat.matrix.length);
			
			// update g1
			mat_genes = new HashSet<String>(all_data_mat.genesID);
			gene2index = new Hashtable<String, Integer>();
			for (int i = 0; i < all_data_mat.genesID.size(); i++) {
				gene2index.put(all_data_mat.genesID.get(i), i);
			}
			g1 = AlgorithmComparison_main_for_binary_graphs.getGraphAsMatrix(args[4], mat_genes, gene2index);
			Runtime.getRuntime().gc();
		}
		
		DICER_main analyzer = new DICER_main(all_data_mat,args[1],Integer.parseInt(args[2]));
		analyzer.doStatisticalAnalysis(0.05f,true,false,0.4f);
		if (g1==null){
			g1 = analyzer.getConsistentCorrelationsGraph();
		}
		
		float[][] g2_opt1 = analyzer.uGGraph;
		
		float thr = 0;
		
		MultithreadedComparisonRunner comp = new MultithreadedComparisonRunner(g1, g2_opt1, analyzer.getData().genesID,thr,0.00001f);	
		analyzer=null;
		Runtime.getRuntime().gc();
		comp.doComparisons(true);
		comp.printSeedsStatistics();
		comp.printModuleStatistics();
		
		String outPath = "NSLC_PPI_Down_AD_AutomaticK0.4_maxpmates0.05_alpha0.000001_";
		comp.printModuleSolutions(outPath);
		comp.printSeedSolutions(outPath);
		comp.printMetaGraphs(outPath);

	}

	public static float getThresholdForHGTest(float[][] g2_opt1,float q) {
		float meanPlus = 0;
		float c = 0;
		float[][] m = g2_opt1;
		for (int i = 0; i < m.length; i++) {
			for (int j = 0; j < i; j++) {
				if (m[i][j]>0){
					c++;
					meanPlus+=m[i][j];
				}
			}
		}
		
		System.out.println("mean: "+meanPlus/c);
		return 0;
	}

}
