package main_scripts;

import math_utils.ClassesFileObject;
import math_utils.ExpressionMatrix;

public class DiffCoExpGraphsCalculator {
	int beta = 3;
	float[][] cc;
	float[][] dc;
	
	// implemented for two classes analysis
	public DiffCoExpGraphsCalculator(String GEDataFilePath,String ClassesFilePath) {
		TscoresCalculator tcalc = new TscoresCalculator(GEDataFilePath, ClassesFilePath, "pearson");
		calcDC_CC(tcalc);
	}
	
	public DiffCoExpGraphsCalculator(ExpressionMatrix data, int[] borders,String[] names) {
		TscoresCalculator tcalc = new TscoresCalculator(data, borders,names, "pearson");
		calcDC_CC(tcalc);
	}
	
	public DiffCoExpGraphsCalculator(ClassesFileObject o) {
		TscoresCalculator tcalc = new TscoresCalculator(o.getData(), o.getClassesBorders(),o.getClassesNames(), "pearson");
		calcDC_CC(tcalc);
	}

	public void calcDC_CC(TscoresCalculator tcalc) {
		tcalc.claculateSimilarities();
		float[][] sim1 = tcalc.class2Correlations.get(0);
		float[][] sim2 = tcalc.class2Correlations.get(1);
		int n = sim1.length;
		cc = new float[n][n];
		dc = new float[n][n];
		
		for (int i = 0; i < sim2.length; i++) {
			for (int j = 0; j < sim2.length; j++) {
				float cc1 =  (new Double(Math.pow(sim1[i][j],beta))).floatValue();
				float cc2 =  (new Double(Math.pow(sim2[i][j],beta))).floatValue();
				cc[i][j] = (new Double(Math.min(cc1,cc2))).floatValue();
				
				float diff = sim1[i][j]-sim2[i][j];
				dc[i][j] = (new Double(Math.pow(diff,beta))).floatValue();
			}
		}
	}
	
	public void invertDC(){
		for (int i = 0; i < dc.length; i++) {
			for (int j = 0; j < dc.length; j++) {
				dc[i][j] = -dc[i][j];
			}
		}
	}
	
	public float[][] getCc() {
		return cc;
	}
	public float[][] getDc() {
		return dc;
	}
}
