package math_utils;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

public class ClassesFileObject {
	private int numClasses;
	private int[] classesBorders;
	private String[] ClassesNames;
	private ExpressionMatrix data;

	public ClassesFileObject(String ClassesFilePath) {
		ArrayList<Integer> fromTo = new ArrayList<Integer>();
		ArrayList<String> names = new ArrayList<String>();
		try {
			BufferedReader reader = new BufferedReader(new FileReader(
					ClassesFilePath));
			String currLine = "";
			while ((currLine = reader.readLine()) != null) {
				String[] line = currLine.split("\t");
				if (line.length != 3) {
					System.out.println("divide to classes file is not valid");
					System.exit(1);
				}
				numClasses++;
				fromTo.add(Integer.parseInt(line[0]));
				fromTo.add(Integer.parseInt(line[1]));
				names.add(line[2]);
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		classesBorders = new int[fromTo.size()];
		for (int i = 0; i < classesBorders.length; i++) {
			classesBorders[i] = fromTo.get(i);
		}
		ClassesNames = new String[names.size()];
		for (int i = 0; i < ClassesNames.length; i++) {
			ClassesNames[i] = names.get(i);
		}
		classesBorders[classesBorders.length - 1] = data.getMatrix()[0].length - 1;
	}
	public ClassesFileObject(int nClasses,int[] borders, String[] name, ExpressionMatrix d) {
		numClasses=nClasses;
		classesBorders=borders;
		ClassesNames=name;
		data=d;
	}
	
	public int[] getClassesBorders() {
		return classesBorders;
	}
	public String[] getClassesNames() {
		return ClassesNames;
	}
	public int getNumClasses() {
		return numClasses;
	}
	
	public ExpressionMatrix getData() {
		return data;
	}
}
