package math_utils;

/*
 * Created on 09/11/2005
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

import edu.tau.compbio.ds.*;
import edu.tau.compbio.expression.ds.*;
/**
 * @author Adi Maron-Katz
 *
 */
public class PercentileCalc {
	static final int DEF_SAMPLE_VEC_SIZE = 2000;
	public static float calcPercentile(int inPer, MatrixData inData, boolean accurate){
		float[] vec;
		int rows = inData.sizeProbes();
		int cols = inData.sizeConditions();
		int vesSize;
		if(accurate)
			vec = getSampleVec(rows*cols, inData);
		else
			vec = getSampleVec(DEF_SAMPLE_VEC_SIZE, inData);
							
		
		return edu.tau.compbio.math.VecCalc.getPercentile(inPer,vec );
	}
	
	/**
	 * 
	 * @param inFromPer
	 * @param inToPer
	 * @param inData
	 * @param accurate
	 * @return
	 */
	public static float[] calcPercentiles(int inFromPer, int inToPer, MatrixData inData, boolean accurate){
		float[] vec;
		int rows = inData.sizeProbes();
		int cols = inData.sizeConditions();
		int vesSize;
		if(accurate)
			vec = getSampleVec(rows*cols, inData);
		else
			vec = getSampleVec(DEF_SAMPLE_VEC_SIZE, inData);
							
		
		return edu.tau.compbio.math.VecCalc.getPercentiles(inFromPer, inToPer,vec );
	}
	
	/**
	 * 
	 * @param inFromPer
	 * @param inToPer
	 * @param inData
	 * @param accurate
	 * @return
	 */
	public static float[] calcPercentiles(int inFromPer, int inToPer, MatrixData[] inData, boolean accurate){
		float[][] vecs = new float[inData.length][];
		

		if(! accurate){
			for(int i=0; i<inData.length; i++)
				vecs[i] = getSampleVec(DEF_SAMPLE_VEC_SIZE/inData.length, inData[i]);
		}
		else{
		int numOfValues  = 0;
		for(int i=0; i<inData.length; i++)
			numOfValues+=inData[i].sizeProbes()*inData[i].sizeConditions();
		int vesSize;
		for(int i=0; i<inData.length; i++)
			vecs[i] = getSampleVec(inData[i].sizeProbes()*inData[i].sizeConditions(), inData[i]);
		}
							
		
		return edu.tau.compbio.math.VecCalc.getPercentiles(inFromPer, inToPer,vecs );
	}
		
	/**
	 * 
	 * @param inSize
	 * @param inData
	 * @return
	 */
		public static float[] getSampleVec(int inSize, MatrixData inData) {
				java.util.Random random = new java.util.Random();
				int rows = inData.sizeProbes();
				int cols = inData.sizeConditions();
				int numOfValues = rows * cols;
				float[] res;
				if (numOfValues <= inSize) {
					res = new float[numOfValues];
					for (int i = 0; i < rows; i++) {
						float[] row_i = inData.getDataRow(i);
						for (int j = 0; j < cols; j++)
							res[i * cols + j] = row_i[j];
					}
				} else {
					numOfValues = inSize;
					res = new float[numOfValues];
					int row, col;
					for (int i = 0; i < numOfValues; i++) {
						row = random.nextInt(rows);	
						col = random.nextInt(cols);
					
						res[i] = inData.getFloatValue(row,col).floatValue();
						// if(res[i]>3 && i>0) //for debugging
						//  res[i] = res[i-1];
					}
				}
				//sampleVec = res;
				return res;
			}

		
		/**
		 * 
		 * @param inSize
		 * @param inData
		 * @return
		 */
	/*		public static float[] getSampleVec(int inSize, MatrixData[] inData) {
					java.util.Random random = new java.util.Random();
					int numOfValues  = 0;
					for(int i=0; i<inData.length; i++)
						numOfValues+=inData[i].sizeProbes()*inData[i].sizeConditions();

					float[] res;
					if (numOfValues <= inSize) {
						res = new float[numOfValues];
						for(int matInd = 0, pos=0; matInd< inData.length; matInd++){
						int rows = inData[matInd].sizeProbes();
						int cols = inData[matInd].sizeConditions();
						for (int i = 0; i < rows; i++) {
							float[] row_i = inData[matInd].getDataRow(i);
							for (int j = 0; j < cols; j++)
								res[pos] = row_i[j];
								pos++;
							}
						}
					} else {
						numOfValues = inSize;
						res = new float[numOfValues];
						int row, col, mat;
						int mats = inData.length;
						for (int i = 0; i < numOfValues; i++) {
							mat = random.nextInt(mats);
							int rows = inData[mat].sizeProbes();
							int cols = inData[mat].sizeConditions();
							row = random.nextInt(rows);	
							col = random.nextInt(cols);
						
							res[i] = inData[mat].getFloatValue(row,col).floatValue();
							// if(res[i]>3 && i>0) //for debugging
							//  res[i] = res[i-1];
						}
					}
					//sampleVec = res;
					return res;
				}*/

		
}
