package math_utils;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Random;

public class StaticGraphFunctions {
	
	public static LinkedList<LinkedList<Integer>> getStupidMaxCut(int[] group,short[][] matrix){
		LinkedList<Integer> S=new LinkedList<Integer>();
		LinkedList<Integer> T = new LinkedList<Integer>();
		float[] distanceToS = new float[group.length];
		float[] distanceToT = new float[group.length];
		boolean[] inS = new boolean[group.length];
		for (int i = 0; i < group.length; i++) {
			if ((i % 2)==0){
				inS[i]=true;
			}
			else{
				inS[i]=false;
			}
		}
		for (int i = 0; i < inS.length; i++) {
			for (int j = 0; j < inS.length; j++) {
				if (i==j){
					continue;
				}
				if (inS[j]){
					distanceToS[i]+=matrix[group[i]][group[j]];
				}
				else{
					distanceToT[i]+=matrix[group[i]][group[j]];
				}
			}
		}
		
		while (true){
			boolean swapped = false;
			for (int i = 0; i < inS.length; i++) {
				if (inS[i] && distanceToS[i]>distanceToT[i]){
//					System.out.println("removing from S " + i);
					inS[i]=false;
					swapped = true;
					for (int j=0;j<distanceToS.length;j++) {
						if (i!=j){
							distanceToS[j]-=matrix[group[i]][group[j]];
							distanceToT[j]+=matrix[group[i]][group[j]];
						}
					}
				}
				
				if ((! inS[i]) && distanceToS[i]<distanceToT[i]){
//					System.out.println("removing from T " + i);
					inS[i]=true;
					swapped = true;
					for (int j=0;j<distanceToS.length;j++) {
						if (i!=j){
							distanceToS[j]+=matrix[group[i]][group[j]];
							distanceToT[j]-=matrix[group[i]][group[j]];
						}
					}
				}
			}
			
			if (! swapped){
				break;
			}
		}

		LinkedList<LinkedList<Integer>> stupidCut = new LinkedList<LinkedList<Integer>>();
		for (int i = 0; i < inS.length; i++) {
			if (inS[i]){
				S.add(group[i]);
			}
			else{
				T.add(group[i]);
			}
		}
		stupidCut.add(S);
		stupidCut.add(T);

		return stupidCut;
	}
	
	
	public static LinkedList<LinkedList<Integer>> getStupidMaxCut(int[] group,float[][] matrix,int startIndex){
		
		LinkedList<Integer> S=new LinkedList<Integer>();
		LinkedList<Integer> T = new LinkedList<Integer>();
		float[] distanceToS = new float[group.length];
		float[] distanceToT = new float[group.length];
		boolean[] inS = new boolean[group.length];
		int maxToSIndex = -1;
		float maxToSVal = -1;
		int maxToTIndex = -1;
		float maxToTVal = -1;
		
		if (startIndex==-1){
			for (int i = 0; i < group.length; i++) {
				inS[i]=true;
				distanceToT[i]=0;
				for (int j = 0; j < distanceToS.length; j++) {
					distanceToS[i]+=matrix[group[i]][group[j]];
				}
				if (distanceToS[i] > maxToSVal){
					maxToSVal = distanceToS[i];
					maxToSIndex = i;
				}
			}
		}
		else{
			for (int i = 0; i < group.length; i++) {
				if (i==startIndex){
					inS[i]=false;
					distanceToT[i]=0;
					for (int j = 0; j < distanceToS.length; j++) {
						distanceToS[i]+=matrix[group[i]][group[j]];
					}
				}
				else{
					inS[i]=true;
					distanceToT[i]= matrix[group[i]][group[startIndex]];;
					for (int j = 0; j < distanceToS.length; j++) {
						if (j==startIndex){
							continue;
						}
						distanceToS[i]+=matrix[group[i]][group[j]];
					}
					if (distanceToS[i] > maxToSVal){
						maxToSVal = distanceToS[i];
						maxToSIndex = i;
					}
				}
			}
		}
		
		
		while (true){
			if (maxToSIndex !=-1 && distanceToS[maxToSIndex]>distanceToT[maxToSIndex]){
				inS[maxToSIndex]=false;
				maxToSVal = -1;
				int oldMaxIndex = maxToSIndex;
				maxToSIndex = -1;
				maxToTVal = -1;
				maxToTIndex = -1;
				for (int i=0;i<distanceToS.length;i++) {
					distanceToS[i]-= matrix[group[i]][group[oldMaxIndex]];
					distanceToT[i]+= matrix[group[i]][group[oldMaxIndex]];
					
					if (inS[i] && distanceToS[i] > maxToSVal){
						maxToSVal = distanceToS[i];
						maxToSIndex = i;
					}
					
					if (!inS[i] && distanceToT[i] > maxToTVal){
						maxToTVal = distanceToT[i];
						maxToTIndex = i;
					}
				}
			}
			else{
				maxToSIndex=-1;
			}
			if (maxToTIndex!=-1 && distanceToT[maxToTIndex]>distanceToS[maxToTIndex]){
//				System.out.println("removing from T");
				inS[maxToTIndex]=true;
				maxToTVal = -1;
				int oldMaxIndex = maxToTIndex;
				maxToTIndex = -1;
				maxToSVal=-1;
				maxToSIndex = -1;
				for (int i=0;i<distanceToS.length;i++) {

					distanceToS[i]+=matrix[group[i]][group[oldMaxIndex]];
					distanceToT[i]-=matrix[group[i]][group[oldMaxIndex]];
					
					if (inS[i] && distanceToS[i] > maxToSVal){
						maxToSVal = distanceToS[i];
						maxToSIndex = i;
					}
					
					if (!inS[i] && distanceToT[i] > maxToTVal){
						maxToTVal = distanceToT[i];
						maxToTIndex = i;
					}
				}
			}
			else{
				maxToTIndex=-1;
			}
			
			if (maxToSIndex==-1 && maxToTIndex==-1){
				break;
			}
		}
//		System.out.println("returning stupid cut");
		LinkedList<LinkedList<Integer>> stupidCut = new LinkedList<LinkedList<Integer>>();
		for (int i = 0; i < inS.length; i++) {
			if (inS[i]){
				S.add(group[i]);
			}
			else{
				T.add(group[i]);
			}
		}
		stupidCut.add(S);
		stupidCut.add(T);
		
		return stupidCut;
	}
	
	
public static LinkedList<LinkedList<Integer>> getStupidMaxCut(int[] group,double[][] matrix,int startIndex){
		
		LinkedList<Integer> S=new LinkedList<Integer>();
		LinkedList<Integer> T = new LinkedList<Integer>();
		double[] distanceToS = new double[group.length];
		double[] distanceToT = new double[group.length];
		boolean[] inS = new boolean[group.length];
		int maxToSIndex = -1;
		double maxToSVal = -1;
		int maxToTIndex = -1;
		double maxToTVal = -1;
		
		if (startIndex==-1){
			for (int i = 0; i < group.length; i++) {
				inS[i]=true;
				distanceToT[i]=0;
				for (int j = 0; j < distanceToS.length; j++) {
					distanceToS[i]+=matrix[group[i]][group[j]];
				}
				if (distanceToS[i] > maxToSVal){
					maxToSVal = distanceToS[i];
					maxToSIndex = i;
				}
			}
		}
		else{
			for (int i = 0; i < group.length; i++) {
				if (i==startIndex){
					inS[i]=false;
					distanceToT[i]=0;
					for (int j = 0; j < distanceToS.length; j++) {
						distanceToS[i]+=matrix[group[i]][group[j]];
					}
				}
				else{
					inS[i]=true;
					distanceToT[i]= matrix[group[i]][group[startIndex]];;
					for (int j = 0; j < distanceToS.length; j++) {
						if (j==startIndex){
							continue;
						}
						distanceToS[i]+=matrix[group[i]][group[j]];
					}
					if (distanceToS[i] > maxToSVal){
						maxToSVal = distanceToS[i];
						maxToSIndex = i;
					}
				}
			}
		}
		
		
		while (true){
			if (maxToSIndex !=-1 && distanceToS[maxToSIndex]>distanceToT[maxToSIndex]){
				inS[maxToSIndex]=false;
				maxToSVal = -1;
				int oldMaxIndex = maxToSIndex;
				maxToSIndex = -1;
				maxToTVal = -1;
				maxToTIndex = -1;
				for (int i=0;i<distanceToS.length;i++) {
					distanceToS[i]-= matrix[group[i]][group[oldMaxIndex]];
					distanceToT[i]+= matrix[group[i]][group[oldMaxIndex]];
					
					if (inS[i] && distanceToS[i] > maxToSVal){
						maxToSVal = distanceToS[i];
						maxToSIndex = i;
					}
					
					if (!inS[i] && distanceToT[i] > maxToTVal){
						maxToTVal = distanceToT[i];
						maxToTIndex = i;
					}
				}
			}
			else{
				maxToSIndex=-1;
			}
			if (maxToTIndex!=-1 && distanceToT[maxToTIndex]>distanceToS[maxToTIndex]){
//				System.out.println("removing from T");
				inS[maxToTIndex]=true;
				maxToTVal = -1;
				int oldMaxIndex = maxToTIndex;
				maxToTIndex = -1;
				maxToSVal=-1;
				maxToSIndex = -1;
				for (int i=0;i<distanceToS.length;i++) {

					distanceToS[i]+=matrix[group[i]][group[oldMaxIndex]];
					distanceToT[i]-=matrix[group[i]][group[oldMaxIndex]];
					
					if (inS[i] && distanceToS[i] > maxToSVal){
						maxToSVal = distanceToS[i];
						maxToSIndex = i;
					}
					
					if (!inS[i] && distanceToT[i] > maxToTVal){
						maxToTVal = distanceToT[i];
						maxToTIndex = i;
					}
				}
			}
			else{
				maxToTIndex=-1;
			}
			
			if (maxToSIndex==-1 && maxToTIndex==-1){
				break;
			}
		}
//		System.out.println("returning stupid cut");
		LinkedList<LinkedList<Integer>> stupidCut = new LinkedList<LinkedList<Integer>>();
		for (int i = 0; i < inS.length; i++) {
			if (inS[i]){
				S.add(group[i]);
			}
			else{
				T.add(group[i]);
			}
		}
		stupidCut.add(S);
		stupidCut.add(T);
		
		return stupidCut;
	}
	
	
	
	public static LinkedList<LinkedList<Integer>> getConnectedComponents(short[][] matrix, int edgeValue) {
		LinkedList<LinkedList<Integer>> CCs = new LinkedList<LinkedList<Integer>>();
		int numOfVertexes = matrix.length;
		boolean[] visited = new boolean[numOfVertexes ];
		Arrays.fill(visited, false);
		int numOfVisited = 0;
		int currIndex = 0;
		while (currIndex < numOfVertexes) {
			if (currIndex >= visited.length) {
				break;
			}
			LinkedList<Integer> currCC = bfsFromVertex(currIndex, visited,matrix,edgeValue);
			CCs.add(currCC);
			for (Iterator<Integer> iterator = currCC.iterator(); iterator
					.hasNext();) {
				Integer node = (Integer) iterator.next();
				visited[node] = true;
				numOfVisited++;
			}
			while (currIndex < visited.length && visited[currIndex]) {
				currIndex++;
			}

			if (numOfVisited == numOfVertexes - 1) {
				break;
			}
		}

		visited = null;
		Runtime.getRuntime().gc();
		return CCs;
	}
	
	public static LinkedList<Integer> getDominatingSetFromAllCCs(short edgeVal,short[][] matrix,int sigSize) {

		LinkedList<Integer> ds = new LinkedList<Integer>();
	
		LinkedList<LinkedList<Integer>> CCs = getConnectedComponents(matrix, edgeVal);
		LinkedList<int[]> CCsArrays = new LinkedList<int[]>();
		LinkedList<boolean[]> visitedInCCs = new LinkedList<boolean[]>();
		
		for (Iterator<LinkedList<Integer>> iterator = CCs.iterator(); iterator.hasNext();) {
			LinkedList<Integer> ccList = (LinkedList<Integer>) iterator.next();
			
			int[] cc = new int[ccList.size()];
			boolean[] ccVisited = new boolean[cc.length];
			
			int counter = 0;
			for (Iterator<Integer> iterator2 = ccList.iterator(); iterator2.hasNext();) {
				Integer index = (Integer) iterator2.next();
				cc[counter] = index;
				counter++;
			}
			
			Arrays.fill(ccVisited, false);
			CCsArrays.add(cc);
			visitedInCCs.add(ccVisited);
		}


		while (true) {
			
			int counter = -1;
			boolean exitFlag = false;
			int countCoveredCCs = 0;
			for (Iterator<int[]> iterator = CCsArrays.iterator(); iterator.hasNext();) {
				counter++;
				int[] cc = (int[]) iterator.next();
				boolean[] visited = visitedInCCs.get(counter);
				
				int maxDegreeVertexIndex = -1;
				int maxDegree = -1;
				for (int i = 0; i < cc.length; i++) {
					if (visited[i]) {
						continue;
					}
					int currVertexCounter = 0;
					for (int j = 0; j < cc.length; j++) {
						if (visited[j] || i == j) {
							continue;
						}
						if (matrix[cc[i]][cc[j]] == edgeVal) {
							currVertexCounter++;
						}
					}
					if (currVertexCounter == 0) {
						visited[i] = true;
						continue;
					}
					if (currVertexCounter > maxDegree) {
						maxDegreeVertexIndex = i;
						maxDegree = currVertexCounter;
					}

				}

				if (maxDegreeVertexIndex == -1 || maxDegree <= 0) {
					countCoveredCCs++;
					continue;
				} else {
					
					if ((ds.size()+maxDegree) > sigSize){
						exitFlag = true;
						break;
					}
					
					visited[maxDegreeVertexIndex] = true;
					ds.add(cc[maxDegreeVertexIndex]);

					for (int i = 0; i < visited.length; i++) {
						if (visited[i]) {
							continue;
						}

						if (matrix[cc[i]][cc[maxDegreeVertexIndex]] == edgeVal) {
							visited[i] = true;
						}
					}
				}
			}
			
			if (exitFlag || countCoveredCCs == CCs.size()){
				break;
			}
		}

		return ds;
	}
	
	
	public static void removeEdgesByDS(short edgeVal,short[][] matrix) {
	
		boolean hasEdges = true;
		boolean[] visited = new boolean[matrix.length];
		Arrays.fill(visited, false);
		while (hasEdges){
			hasEdges = false;
			int maxDegree = -1;
			int maxDegreeIndex = -1;
			for (int i = 0; i < visited.length; i++) {
				if (visited[i]){
					continue;
				}
				
				int currDegree = 0;
				for (int j = 0; j < visited.length; j++) {
					if (visited[j]){
						continue;
					}
					if (matrix[i][j]==edgeVal){
						currDegree++;
					}
				}
				
				if (currDegree >0 && currDegree > maxDegree){
					maxDegree = currDegree;
					maxDegreeIndex = i;
				}
			}
			
			if (maxDegreeIndex==-1){
				break;
			}
			
			// remove all edges of the maxDegreee vertex
			for (int j = 0; j < visited.length; j++) {
				if (visited[j]){
					continue;
				}
				if (matrix[maxDegreeIndex][j]==edgeVal){
					for (int i = 0; i < visited.length; i++) {
						matrix[j][i] = 0;
						matrix[i][j] = 0;
					}
					visited[j]=true;
				}
			}
			visited[maxDegreeIndex]=true;
		}
	}
	
	
	public static LinkedList<Integer> getVCApproximationFromAllCCs(short edgeVal,short[][] matrix,int sigSize) {

		LinkedList<Integer> ds = new LinkedList<Integer>();
	
		LinkedList<LinkedList<Integer>> CCs = getConnectedComponents(matrix, edgeVal);
		LinkedList<int[]> CCsArrays = new LinkedList<int[]>();
		LinkedList<boolean[]> visitedInCCs = new LinkedList<boolean[]>();
		int totalNumOfCCs = 0;
		
		for (Iterator<LinkedList<Integer>> iterator = CCs.iterator(); iterator.hasNext();) {
			LinkedList<Integer> ccList = (LinkedList<Integer>) iterator.next();
			if (ccList.size() <= 1){
				continue;
			}
			totalNumOfCCs++;
			
			int[] cc = new int[ccList.size()];
			boolean[] ccVisited = new boolean[cc.length];
			
			int counter = 0;
			for (Iterator<Integer> iterator2 = ccList.iterator(); iterator2.hasNext();) {
				Integer index = (Integer) iterator2.next();
				cc[counter] = index;
				counter++;
			}
			
			Arrays.fill(ccVisited, false);
			CCsArrays.add(cc);
			visitedInCCs.add(ccVisited);
		}


		while (true) {
			
			int counter = -1;
			boolean exitFlag = false;
			int countCoveredCCs = 0;
			for (Iterator<int[]> iterator = CCsArrays.iterator(); iterator.hasNext();) {
				counter++;
				int[] cc = (int[]) iterator.next();
				boolean[] visited = visitedInCCs.get(counter);
				
				boolean hasEdge = false;
				for (int i = 0; i < cc.length; i++) {
					if (visited[i]) {
						continue;
					}
					if (exitFlag){
						break;
					}
					for (int j = 0; j < cc.length; j++) {
						if (visited[j] || i == j) {
							continue;
						}
						if (matrix[cc[i]][cc[j]] == edgeVal) {
							visited[i]=true;
							visited[j]=true;
							ds.add(cc[i]);
							ds.add(cc[j]);
							hasEdge = true;
							if (ds.size() > sigSize){
								exitFlag = true;
							}
							break;
						}
					}
				}

				if (! hasEdge) {
					countCoveredCCs++;
					continue;
				} else {
					if (ds.size() > sigSize){
						exitFlag = true;
						break;
					}
				}
			}
			
			if (exitFlag || countCoveredCCs == totalNumOfCCs){
				break;
			}
		}

		return ds;
	}
	
	public static LinkedList<Integer> MWVCApproximation(short edgeVal,short[][] matrix,int sigSize,int[] weights) {

		LinkedList<Integer> ds = new LinkedList<Integer>();
	
		LinkedList<LinkedList<Integer>> CCs = getConnectedComponents(matrix, edgeVal);
		LinkedList<int[]> CCsArrays = new LinkedList<int[]>();
		LinkedList<boolean[]> visitedInCCs = new LinkedList<boolean[]>();
		int totalNumOfCCs = 0;
		
		for (Iterator<LinkedList<Integer>> iterator = CCs.iterator(); iterator.hasNext();) {
			LinkedList<Integer> ccList = (LinkedList<Integer>) iterator.next();
			if (ccList.size() <= 1){
				continue;
			}
			totalNumOfCCs++;
			int[] cc = new int[ccList.size()];
			boolean[] ccVisited = new boolean[cc.length];
			
			int counter = 0;
			for (Iterator<Integer> iterator2 = ccList.iterator(); iterator2.hasNext();) {
				Integer index = (Integer) iterator2.next();
				cc[counter] = index;
				counter++;
			}
			
			Arrays.fill(ccVisited, false);
			CCsArrays.add(cc);
			visitedInCCs.add(ccVisited);
		}

		Random rand = new Random();
		
		while (true) {
			
			int counter = -1;
			boolean exitFlag = false;
			int countCoveredCCs = 0;
			for (Iterator<int[]> iterator = CCsArrays.iterator(); iterator.hasNext();) {
				counter++;
				int[] cc = (int[]) iterator.next();
				boolean[] visited = visitedInCCs.get(counter);
				
				boolean hasEdge = false;
				for (int i = 0; i < cc.length; i++) {
					if (visited[i]) {
						continue;
					}
					if (exitFlag){
						break;
					}
					for (int j = 0; j < cc.length; j++) {
						if (visited[j] || i == j) {
							continue;
						}
						if (matrix[cc[i]][cc[j]] == edgeVal) {
							int sumWeights = weights[cc[i]]+weights[cc[j]];
							int selection = rand.nextInt(sumWeights);
							if (selection > weights[cc[i]]){
								visited[i]=true;
								ds.add(cc[i]);
							}
							else{
								visited[j]=true;
								ds.add(cc[j]);
							}
							hasEdge = true;
							if (ds.size() > sigSize){
								exitFlag = true;
							}
							break;
						}
					}
				}

				if (! hasEdge) {
					countCoveredCCs++;
					continue;
				} else {
					if (ds.size() > sigSize){
						exitFlag = true;
						break;
					}
				}
			}
			
			if (exitFlag || countCoveredCCs == totalNumOfCCs){
				break;
			}
		}

		return ds;
	}

	public static LinkedList<Integer> bfsFromVertex
	(int index, boolean[] visited,short[][] matrix,int threshold) {

		// System.out.println("in bfs");
		Queue<Integer> q = new LinkedList<Integer>();
		q.add(index);
		LinkedList<Integer> reachable = new LinkedList<Integer>();

		while (!q.isEmpty()) {
			Integer n = q.remove();
			visited[n] = true;
			reachable.add(n);

			for (int i = 0; i < visited.length; i++) {
				if (n==i){
					continue;
				}
				if (matrix[n][i] == threshold) {
					if (!visited[i]) {
						visited[i] = true;
						q.add(i);
					}
				}
			}
		}
		return reachable;
	}
	
	public static boolean isCCDense(int[] cc,short[][] matrix,float p,short edgeValue){
		int[] degrees = new int[cc.length];
		for (int i = 0; i < degrees.length; i++) {
			for (int j = 0; j < i; j++) {
				if (matrix[cc[i]][cc[j]]==edgeValue){
					degrees[i]++;
					degrees[j]++;
				}
			}
		}
		
		int minDegree = cc.length;
		for (int i = 0; i < degrees.length; i++) {
			if (degrees[i]<minDegree){
				minDegree = degrees[i];
			}
		}
		
		int degreeThreshold = (new Float((cc.length-1)*p)).intValue();
//		System.out.println("degree threshold: " + degreeThreshold);
		if (minDegree >= degreeThreshold){
			return true;
		}
		
		return false;
	}
	
	public static short[][] getRandomExpansion(float[][] graph,int numEdges){
		
		/**
		 * Initialize variables
		 */
		float[] verticesWeights = new float[graph.length];
		boolean[] visited = new boolean[graph.length];
		Arrays.fill(visited, false);
		ArrayList<Integer> geneIndices = new ArrayList<Integer>();
		ArrayList<Float> geneWeights = new ArrayList<Float>();
		float currentSum = 0;
		Random rand = new Random();
		
		
		float totalSum=0;
		for (int i = 0; i < verticesWeights.length; i++) {
			for (int j = 0; j < verticesWeights.length; j++) {
				verticesWeights[i]+=graph[i][j];
			}
			totalSum+=verticesWeights[i];
		}
		
		
		
		// Select the first vertex randomly
		float nextFloat = rand.nextFloat();
		nextFloat*=totalSum;
		float currSumForVertexAssignment = 0;
		for (int i = 0; i < verticesWeights.length; i++) {
			if (nextFloat>=currSumForVertexAssignment && nextFloat <= verticesWeights[i]+currSumForVertexAssignment){
				geneIndices.add(i);
				geneWeights.add(verticesWeights[i]);
				visited[i]=true;
				currentSum+=verticesWeights[i];
				break;
			}
			currSumForVertexAssignment+=verticesWeights[i];
		}
		
		int countEdges = 0;
		short[][] outputGraph = new short[graph.length][graph.length];
		int steps = 0;
		boolean allverticesCovered=false;
		while (numEdges > countEdges ){
			steps++;
			
			//1. select the next vertex randomly
			// from our pool of selected nodes
			nextFloat = rand.nextFloat();
			nextFloat*= currentSum;
			currSumForVertexAssignment = 0;
			int selected=-1;
			for (int i = 0; i < geneIndices.size(); i++) {
				if (nextFloat>=currSumForVertexAssignment && nextFloat <= geneWeights.get(i)+currSumForVertexAssignment){
					selected = geneIndices.get(i);
					break;
				}
				currSumForVertexAssignment+=geneWeights.get(i);
			}
			
			// every 10 steps we must select a new vertex
			if ((steps % 10)==0 && !allverticesCovered){
				float sumToNewVertices=0;
				for (int i = 0; i < graph.length; i++) {
					if (!visited[i]){
						sumToNewVertices+=graph[selected][i];
					}
				}
				
				nextFloat = rand.nextFloat();
				nextFloat*=sumToNewVertices;
				currSumForVertexAssignment = 0;
				int selectedNeighbor=-1;
				allverticesCovered=true;
				for (int i = 0; i < graph.length; i++) {
					if (visited[i]){
						continue;
					}
					allverticesCovered=false;
					if (nextFloat>=currSumForVertexAssignment && nextFloat <= verticesWeights[i]+currSumForVertexAssignment){
						selectedNeighbor=i;
						visited[selectedNeighbor]=true;
						geneIndices.add(i);
						geneWeights.add(verticesWeights[i]);
						currentSum+=verticesWeights[i];
						
						outputGraph[selected][selectedNeighbor]=(short)1;
						outputGraph[selectedNeighbor][selected]=(short)1;
						countEdges++;
						
						break;
					}
					currSumForVertexAssignment+=verticesWeights[i];
				}
				
			}
			else{
				
				// here we select an edge by random
				float sumToVertices=0;
				for (int i = 0; i < graph.length; i++) {
					if (outputGraph[selected][i]==0)
					sumToVertices+=graph[selected][i];
				}
				
				nextFloat = rand.nextFloat();
				nextFloat*=sumToVertices;
				currSumForVertexAssignment = 0;
				int selectedNeighbor=-1;
				for (int i = 0; i < graph.length; i++) {	
					if (outputGraph[i][selected]==1){
						continue;
					}
					if (nextFloat>=currSumForVertexAssignment && nextFloat <= verticesWeights[i]+currSumForVertexAssignment){
						selectedNeighbor=i;
						visited[selectedNeighbor]=true;
						geneIndices.add(i);
						geneWeights.add(verticesWeights[i]);
						currentSum+=verticesWeights[i];
						
						if (outputGraph[selected][selectedNeighbor]==0){
							outputGraph[selected][selectedNeighbor]=(short)1;
							outputGraph[selectedNeighbor][selected]=(short)1;
							countEdges++;
						}
						
						break;
					}
					currSumForVertexAssignment+=verticesWeights[i];
				}
			}			
		}
		
		
		
		return outputGraph;
	}
	
	
	
}
