package multithreaded_algo_runs;

import global_analysis.GreedyHillClimber;

import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

public class GlobalImproveThread extends Thread {
	String curr_algo;
	MultithreadedComparisonRunner father;
	boolean disc;
	float alpha = -1;
	boolean correctPs = false;
	
	public GlobalImproveThread(MultithreadedComparisonRunner f, String name, boolean d) {
		father=f;
		curr_algo = name;
		disc=d;
		start();
	}
	
	public GlobalImproveThread(MultithreadedComparisonRunner f, String name, boolean d, float alpha) {
		this.alpha=alpha;
		father=f;
		curr_algo = name;
		disc=d;
		start();
	}
	
	public GlobalImproveThread(MultithreadedComparisonRunner f, String name, boolean d, float alpha,boolean c) {
		this.alpha=alpha;
		father=f;
		curr_algo = name;
		disc=d;
		correctPs = c;
		start();
	}

	@Override
	public void run() {
		Collection<HashSet<Integer>> modules = father.algo2seed.get(curr_algo);
		if (modules==null || modules.size()==0){
			String newAlgoName = curr_algo+"_"+"global";
			father.algo2modulesAfterImprovement.put(newAlgoName, new LinkedList<HashSet<Integer>>());
			father.algo2CMPs.put(newAlgoName, new short[1][1]);
			return;
		}
		GreedyHillClimber climber = new GreedyHillClimber(father.g1, father.g2,father.edgethr, 
				new LinkedList<HashSet<Integer>>(father.algo2seed.get(curr_algo)),disc,father.minModuleSize);
		climber.runImprovementStage(correctPs);
		climber.updateModuleList(father.minModuleSize, 1);
		
		if (alpha>0){
			List<HashSet<Integer>> ms = climber.getModulesCopy();
			climber = null;
			Runtime.getRuntime().gc();
			climber = new GreedyHillClimber(father.g1, father.g2,father.edgethr, ms, disc,alpha);
			climber.updateModuleList(father.minModuleSize, 1);
		}
		
		String newAlgoName = curr_algo+"_"+"global";
		father.algo2modulesAfterImprovement.put(newAlgoName, climber.getModulesCopy());
		father.algo2CMPs.put(newAlgoName, climber.getAreModulesFriends());
		climber=null;
		Runtime.getRuntime().gc();
		System.out.flush();
	}
}
