package multithreaded_algo_runs;

import graph_algorithms.HierarchicalClusterer;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import main_scripts.AlgorithmComparisonRunner;

public class HierarchicalClusteringThread extends Thread {
	
	String run_name;
	MultithreadedComparisonRunner father;
	
	public HierarchicalClusteringThread(MultithreadedComparisonRunner f, String algoName) {
		run_name=algoName;
		father=f;
		start();
	}

	@Override
	public void run() {
		List<HashSet<Integer>> hierSeeds = HierarchicalClusterer
				.doCompleteHierarchicalClustering(0, father.getG1(), 1);
		father.updateHashForSeedAlgorithm(run_name,
				new LinkedList<HashSet<Integer>>(hierSeeds));
		System.out.println(AlgorithmComparisonRunner.getModuleStatistics(hierSeeds));
		System.out.flush();
	}

}
