package multithreaded_algo_runs;

import graph_algorithms.BiModulesFinderUsingClusteringSol;

import java.util.HashSet;
import java.util.LinkedList;

public class LocalImproveThread extends Thread {
	String curr_algo;
	MultithreadedComparisonRunner father;
	
	public LocalImproveThread(MultithreadedComparisonRunner f, String name) {
		father=f;
		curr_algo = name;
		start();
	}

	@Override
	public void run() {
		
		BiModulesFinderUsingClusteringSol improver = new BiModulesFinderUsingClusteringSol(father.g1, father.g2, father.nodeIds);
		improver.setClusters(new LinkedList<HashSet<Integer>>(father.algo2seed.get(curr_algo)));
		improver.findSeedPairs(2);
		improver.improveSolution(father.minModuleSize);
		improver.calculateMetaGraph();
		String algoName = curr_algo+"_local";
		father.algo2modulesAfterImprovement.put(algoName, improver.getModulesCopy());
		father.algo2CMPs.put(algoName, improver.getAreModulesFriends());
		improver=null;
		Runtime.getRuntime().gc();
		System.out.flush();
	}
}
