package scripts;

import math_utils.ExpressionMatrix;
import math_utils.staticMathHelperMethods;

/**
 * 
 * This script receives as input an expression matrix file, a sample size,
 * and two more optional parameters: from, to.
 * The script sample gene pairs and calculates their correlation.
 * The size of the sample is the second parameter.
 * If from,to are given then the correlations are calculated using only
 * the sample in the from-to window.
 * Expression matrix format: tab delimited file.
 * Rows are genes\probes, columns are samples. First row\column is the row\column name.
 *
 */

public class CorrelationsSampler {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		if (args.length < 2){
			System.out.println("Usage <GE file><sample size>" +
					"Optional : from,to");
			System.exit(-1);
		}
		
		ExpressionMatrix data = new ExpressionMatrix(args[0]);
		int sampleSize = Integer.parseInt(args[1]);
		float[] sample=null;
		if (args.length==2){
			sample = staticMathHelperMethods.getSortedRealScoresSample
				(data.matrix, sampleSize, "pearson",true);
		}
		else{
			int from = Integer.parseInt(args[2]);
			int to = Integer.parseInt(args[3]);
			sample = staticMathHelperMethods.getSortedRealScoresSample
				(data.matrix, sampleSize, "pearson",from,to,true);
		}
		
		for (int i = 0; i < sample.length; i++) {
			System.out.println(sample[i]);
		}

	}

}
