package scripts;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import main_scripts.TscoresCalculator;
import math_utils.ExpressionMatrix;



public class GetMaximumValueInSimMatrix {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		System.out.println("usage: <classest><ge mat><wanted genes>");
		
		ExpressionMatrix expmat = new ExpressionMatrix(args[1]);
		
		TscoresCalculator algo =  new TscoresCalculator(expmat,args[0] , "pearson");
		algo.claculateSimilarities();
		
		double sim1 = 0.2;
		double sim2 = 0.6;
		
		ArrayList<Integer> wantedGenes = new ArrayList<Integer>();
		try {
			BufferedReader reader = new BufferedReader(new FileReader(args[2]));
			String l = "";
			int c = 0;
			while ((l= reader.readLine())!=null){
				wantedGenes.add(expmat.genesID.indexOf((l.split("\t"))[0]));
				if (expmat.genesID.indexOf((l.split("\t"))[0]) >= 0){
					c++;
				}
			}
			System.out.println(c + " genes in cluster");
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		double max = -Double.MAX_VALUE;
		int maxI = -1;
		int maxJ = -1;
		for (int i = 0; i < wantedGenes.size(); i++) {
			for (int j = 0; j < i; j++) {
				
				double c1AbSim = algo.class2Correlations.get(0)[wantedGenes.get(i)][wantedGenes.get(j)];
				if (c1AbSim <0){
					c1AbSim*=-1;
				}
				
				double c2AbSim = algo.class2Correlations.get(1)[wantedGenes.get(i)][wantedGenes.get(j)];
				if (c2AbSim < 0){
					c2AbSim*=-1;
				}
				
				double diff = Math.abs(c1AbSim-c2AbSim);
				System.out.println(diff);
				
				if (diff < sim2-sim1){
					continue;
				}
				
//				if (c1AbSim > sim1 && c1AbSim < sim2){
//					continue;
//				}
//				
//				if (c2AbSim > sim1 && c2AbSim<sim2){
//					continue;
//				}
				
				if (max < diff){
					max = diff;
					maxI = wantedGenes.get(i);
					maxJ = wantedGenes.get(j);
				}
			}
		}
		
		System.out.println(expmat.genesID.get(maxI)+"\t"+expmat.genesID.get(maxJ)+"\t"+max);
		
		
		float[][] iv = new float[2][expmat.matrix[maxI].length];
		iv[0] = expmat.matrix[maxI];
		iv[1] = expmat.matrix[maxJ];
//		staticHelperMethods.standardizeByGenes(iv);
		int[] borders = algo.getClassesBorders();
		for (int i = borders[0]; i < borders[1]; i++) {
			System.out.print(iv[0][i]+"\t");
		}
		System.out.println();

		for (int i = borders[0]; i < borders[1]; i++) {
			System.out.print(iv[1][i]+"\t");
		}
		System.out.println();
		
		
		for (int i = borders[2]; i < borders[3]; i++) {
			System.out.print(iv[0][i]+"\t");
		}
		System.out.println();

		for (int i = borders[2]; i < borders[3]; i++) {
			System.out.print(iv[1][i]+"\t");
		}
		System.out.println();

	}
	
	public static double[][] readMatrix(String path) {
		double[][] mat = null;
		try {
			BufferedReader reader = new BufferedReader(new FileReader(path));
			String line = reader.readLine();
			line.trim();
			String[] firstLine = line.split("\t");
			int n = firstLine.length;
			mat = new double[n][n];
			for (int i = 0; i < firstLine.length; i++) {
				mat[0][i] = Double.parseDouble(firstLine[i]);
			}

			// read next lines
			for (int i = 1; i < mat.length; i++) {
				line = reader.readLine();
				line.trim();
				firstLine = line.split("\t");
				for (int j = 0; j < firstLine.length; j++) {
					mat[i][j] = Double.parseDouble(firstLine[j]);
				}
			}
			reader.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return mat;
	}

}
