package scripts;

import java.util.HashSet;
import java.util.Hashtable;

import scripts.HyperGeometricEnrichmentAnalysis;

import math_utils.ExpressionMatrix;

public class ManyEnrichmentTests {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		if (args.length!=3){
			System.out.println("usage: <ge data><clusters file><fdr>");
			System.exit(1);
		}
		
		ExpressionMatrix mat = new ExpressionMatrix(args[0]);
		HashSet<String> bg = new HashSet<String>(mat.genesID);
		double fdr = Double.parseDouble(args[2]);
		
		// perform enrichment analyses
		String keggPath = "humanGenes2KeggNames.txt";
		String OMIMpath = "EntrezId2DiseaseMIM.txt";
		String pathologyPath = "EntrezId2Pathology.txt";
		String complexesPath = "Entrez2ProteinComplexes.txt";
//		String miRNATargets = "FAMEData.txt";
		String anatomicalDataPath = "EntrezId2AnatomicalData.txt";
		System.out.println("****** enrichment results ******");
		System.out.println("###KEGG###");
		Hashtable<String, HashSet<String>> seeds = HyperGeometricEnrichmentAnalysis.readGeneSets(args[1], bg);
		HyperGeometricEnrichmentAnalysis anal = new HyperGeometricEnrichmentAnalysis(
				keggPath, mat.getGenesID(), seeds);
		anal.minOverlap=5;
		anal.printResultsStatisticsRemoveDuplications(fdr);
		anal.printResults(fdr);
		anal.printGenes();
		System.out.println("###Complexes###");
		anal = new HyperGeometricEnrichmentAnalysis(complexesPath,
				mat.getGenesID(), seeds);
		anal.printResultsStatisticsRemoveDuplications(fdr);
		anal.printResults(fdr);
		anal.printGenes();
		System.out.println("###Anatomical###");
		anal = new HyperGeometricEnrichmentAnalysis(anatomicalDataPath,
				mat.getGenesID(), seeds);
		anal.printResultsStatisticsRemoveDuplications(fdr);
		anal.printResults(fdr);
		anal.printGenes();
		System.out.println("###MIM###");
		anal = new HyperGeometricEnrichmentAnalysis(OMIMpath,
				mat.getGenesID(), seeds);
		anal.printResultsStatisticsRemoveDuplications(fdr);
		anal.printResults(fdr);
		anal.printGenes();
		System.out.println("###Pathology###");
		anal = new HyperGeometricEnrichmentAnalysis(pathologyPath,
				mat.getGenesID(), seeds);
		anal.printResultsStatisticsRemoveDuplications(fdr);
		anal.printResults(fdr);
		anal.printGenes();
		
	}

}
